/*
Adott az n elemű (3 ≤ n ≤ 100), növekvően rendezett x sorozat, amely 30 000-nél kisebb különböző természetes 
számokat tartalmaz. A legközelebbi(x, bal, jobb, ér) algoritmus meghatározza az x sorozat legnagyobb értékű elemének 
pozícióját, amely a bal és jobb pozíciók között helyezkedik el (1 ≤ bal < jobb ≤ n) és, amelynek az értéke kisebb, 
vagy egyenlő ér-rel. Ha nem létezik ilyen elem, a legközelebbi(x, bal, jobb, ér) algoritmus 0-t térít vissza.
A modulusz(a) algoritmus az a egész szám abszolút-értékét téríti vissza.
A számol(n, x, adottSz) algoritmus meghatározza azt az elemét az x sorozatnak, amely a legközelebb áll adottSz-hoz. 
Ha két elem azonosan közel van adottSz értékéhez, az algoritmus a nagyobb számot határozza meg.
Legyen n = 5, x = (5, 9, 11, 15, 99) és adottSz = 12. Állapítsátok meg melyik kHaejezéssel helyettesíthető a 
„…” a legközelebbi(x, bal, jobb, ér) algoritmusban, ahhoz, hogy a számol(n, x, adottSz) algoritmus 11-et térítsen 
vissza.
*/

#include <iostream>
#include <fstream>
#include <math.h>

using namespace std;

int const maxDim = 100;

ifstream fin("7_sorozat.in");

void beOlvas(int & n, int x[]){

	fin >> n;
	for(int i = 1; i <= n; i++)
		fin >> x[i];	
}

void kiIr(int n, int x[]){

	for(int i = 1; i <= n; i++)
		cout << x[i] << " ";
	cout << endl;
}

int binKer(int x[], int bal, int jobb, int keresett){

	if (keresett > x[jobb])
		return jobb;
	if (keresett < x[bal])
		return bal - 1;
	int kozep = (bal + jobb) / 2;

// A.	x[közép - 1] <= ér és ér < x[közép]
// B.	x[közép - 1] <= ér vagy ér < x[közép]
// C.	x[közép - 1] < ér és ér <= x[közép]
// D.	x[közép] <= ér és ér < x[közép - 1]

// 	if(x[kozep - 1] <= keresett && keresett < x[kozep]){
//	if((x[kozep - 1] <= keresett) || (keresett < x[kozep])){
//	if(x[kozep - 1] < keresett && keresett <= x[kozep]){
//	if(x[kozep] <= keresett && keresett < x[kozep - 1]){
//		cout << "*********" << kozep - 1 << " " << x[kozep - 1] << endl;
//		return kozep - 1;
//	}

//	else 
		if (keresett < x[kozep])
			return binKer(x, bal, kozep - 1, keresett); 
		else
			return binKer(x, kozep + 1, jobb, keresett); 
}

int absz(int a){

	if(a < 0)
		a = -a;
	return a;
}

void kiIrEredmeny(int n, int x[], int keresett){

	int hely = binKer(x, 1, n, keresett);

	if(hely == 0)
		cout << "A " << keresett << "-hez legkozelebbi ertek = " << x[hely + 1] << endl;
	else{
		if(absz(x[hely] - keresett) < absz(x[hely + 1] - keresett))
			cout << "A " << keresett << "-hez legkozelebbi ertek = " << x[hely] << endl;
		else
			cout << "A " << keresett << "-hez legkozelebbi ertek = " << x[hely + 1] << endl;
	}
}

int main(){
	int n;
	int x[maxDim];
	beOlvas(n, x);
	kiIr(n, x);
	int keresett;
	cout << "keresett = "; cin >> keresett;
	kiIrEredmeny(n, x, keresett);
}
